/* SPDX-License-Identifier: GPL-2.0 */
#ifndef _LINUX_IEE_DEF_H
#define _LINUX_IEE_DEF_H

enum {
	IEE_OP_MEMCPY,
	IEE_OP_MEMSET,
	IEE_OP_SET_FREEPTR,
	IEE_OP_SPLIT_HUGE_PMD,
	IEE_OP_SET_TOKEN_PGD,
	IEE_OP_INIT_TOKEN,
	IEE_OP_INVALIDATE_TOKEN,
	IEE_OP_VALIDATE_TOKEN,
	IEE_OP_UNSET_TOKEN,
	IEE_OP_SET_TOKEN,
	IEE_OP_TEST_CLEAR_BIT,
	IEE_SET_SENSITIVE_PTE,
	IEE_UNSET_SENSITIVE_PTE,
#ifdef CONFIG_PTP
	IEE_OP_SET_PTE,
	IEE_OP_SET_PMD,
	IEE_OP_SET_PUD,
	IEE_OP_SET_P4D,
	IEE_OP_SET_PGD,
#endif
#ifdef CONFIG_IEE_SELINUX_P
	IEE_SEL_SET_STATUS_PG,
	IEE_SEL_SET_ENFORCING,
	IEE_SEL_SET_INITIALIZED,
	IEE_SEL_SET_POLICY_CAP,
	IEE_SEL_RCU_ASSIGN_POLICY,
#endif
#ifdef CONFIG_CREDP
	IEE_OP_COPY_CRED,
	IEE_OP_SET_CRED_UID,
	IEE_OP_SET_CRED_GID,
	IEE_OP_SET_CRED_SUID,
	IEE_OP_SET_CRED_SGID,
	IEE_OP_SET_CRED_EUID,
	IEE_OP_SET_CRED_EGID,
	IEE_OP_SET_CRED_FSUID,
	IEE_OP_SET_CRED_FSGID,
	IEE_OP_SET_CRED_USER,
	IEE_OP_SET_CRED_USER_NS,
	IEE_OP_SET_CRED_GROUP_INFO,
	IEE_OP_SET_CRED_SECUREBITS,
	IEE_OP_SET_CRED_CAP_INHER,
	IEE_OP_SET_CRED_CAP_PERM,
	IEE_OP_SET_CRED_CAP_EFFECT,
	IEE_OP_SET_CRED_CAP_BSET,
	IEE_OP_SET_CRED_CAP_AMBIENT,
	IEE_OP_SET_CRED_JIT_KEYRING,
	IEE_OP_SET_CRED_SESS_KEYRING,
	IEE_OP_SET_CRED_PROC_KEYRING,
	IEE_OP_SET_CRED_THREAD_KEYRING,
	IEE_OP_SET_CRED_REQ_KEYRING,
	IEE_OP_SET_CRED_NON_RCU,
	IEE_OP_SET_CRED_ATSET_USAGE,
	IEE_OP_SET_CRED_ATOP_USAGE,
	IEE_OP_SET_CRED_SECURITY,
	IEE_OP_SET_CRED_RCU,
	IEE_OP_SET_CRED_UCOUNTS,
#endif
#ifdef CONFIG_KEYP
	IEE_OP_SET_KEY_UNION,
	IEE_OP_SET_KEY_STRUCT,
	IEE_OP_SET_KEY_PAYLOAD,
	IEE_OP_SET_KEY_USAGE,
	IEE_OP_SET_KEY_SERIAL,
	IEE_OP_SET_KEY_WATCHERS,
	IEE_OP_SET_KEY_USERS,
	IEE_OP_SET_KEY_SECURITY,
	IEE_OP_SET_KEY_EXPIRY,
	IEE_OP_SET_KEY_REVOKED_AT,
	IEE_OP_SET_KEY_LAST_USED_AT,
	IEE_OP_SET_KEY_UID,
	IEE_OP_SET_KEY_GID,
	IEE_OP_SET_KEY_PERM,
	IEE_OP_SET_KEY_QUOTALEN,
	IEE_OP_SET_KEY_DATALEN,
	IEE_OP_SET_KEY_STATE,
	IEE_OP_SET_KEY_MAGIC,
	IEE_OP_SET_KEY_FLAGS,
	IEE_OP_SET_KEY_INDEX_KEY,
	IEE_OP_SET_KEY_HASH,
	IEE_OP_SET_KEY_LEN_DESC,
	IEE_OP_SET_KEY_TYPE,
	IEE_OP_SET_KEY_TAG,
	IEE_OP_SET_KEY_DESCRIPTION,
	IEE_OP_SET_KEY_RESTRICT_LINK,
	IEE_OP_SET_KEY_FLAG_BIT,
#endif
	IEE_FLAG_END
};

#ifdef CONFIG_CREDP
#define AT_ADD 1
#define AT_INC_NOT_ZERO 2
#define AT_SUB_AND_TEST 3
#endif

#ifdef CONFIG_KEYP
#define REFCOUNT_INC 1
#define REFCOUNT_SET 2
#define REFCOUNT_DEC_AND_TEST 3
#define REFCOUNT_INC_NOT_ZERO 4

#define SET_BIT_OP 1
#define TEST_AND_CLEAR_BIT 2
#define TEST_AND_SET_BIT 3
#endif

#endif /* _LINUX_IEE_DEF_H */
